scala.reflect.macros

# Typers

###
Related Doc: package macros

#### trait Typers extends AnyRef

EXPERIMENTAL

A slice of the Scala macros context that partially exposes the type checker to macro writers.

Self Type
  blackbox.Context
Source
  Typers.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Context, Context
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Typers
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type TypecheckException = macros.TypecheckException

   See also

     `scala.reflect.macros.TypecheckException`

2. #### abstract type TypecheckMode

   Represents mode of operations of the typechecker underlying `c.typecheck` calls.

   Represents mode of operations of the typechecker underlying `c.typecheck` calls. Is necessary since the shape of the typechecked tree alone is not enough to guess how it should be typechecked. Can be EXPRmode (typecheck as a term), TYPEmode (typecheck as a type) or PATTERNmode (typecheck as a pattern).

### Abstract Value Members

1. #### abstract val PATTERNmode: blackbox.Context.TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a pattern.

2. #### abstract val TERMmode: blackbox.Context.TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a term.

   Indicates that an argument to `c.typecheck` should be typechecked as a term. This is the default typechecking mode in Scala 2.11 and the only one supported in Scala 2.10.

3. #### abstract val TYPEmode: blackbox.Context.TypecheckMode

   Indicates that an argument to `c.typecheck` should be typechecked as a type.

4. #### abstract def inferImplicitValue(pt: blackbox.Context.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: blackbox.Context.Position = enclosingPosition): blackbox.Context.Tree

   Infers an implicit value of the expected type `pt` in the macro callsite context.

   Infers an implicit value of the expected type `pt` in the macro callsite context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   If `silent` is false, `TypecheckException` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typecheck`, `silent` is true by default.

   Exceptions thrown

     `scala.reflect.macros.TypecheckException`

5. #### abstract def inferImplicitView(tree: blackbox.Context.Tree, from: blackbox.Context.Type, to: blackbox.Context.Type, silent: Boolean = true, withMacrosDisabled: Boolean = false, pos: blackbox.Context.Position = enclosingPosition): blackbox.Context.Tree

   Infers an implicit view from the provided tree `tree` of the type `from` to the type `to` in the macro callsite context.

   Infers an implicit view from the provided tree `tree` of the type `from` to the type `to` in the macro callsite context. Optional `pos` parameter provides a position that will be associated with the implicit search.

   If `silent` is false, `TypecheckException` will be thrown in case of an inference error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Xlog-implicits. Unlike in `typecheck`, `silent` is true by default.

   Exceptions thrown

     `scala.reflect.macros.TypecheckException`

6. #### abstract def openMacros: List[blackbox.Context]

   Contexts that represent macros in-flight, including the current one.

   Contexts that represent macros in-flight, including the current one. Very much like a stack trace, but for macros only. Can be useful for interoperating with other macros and for imposing compiler-friendly limits on macro expansion.

   Is also priceless for emitting sane error messages for macros that are called by other macros on synthetic (i.e. position-less) trees. In that dire case navigate the `openMacros` stack, and it will most likely contain at least one macro with a position-ful macro application. See `enclosingPosition` for a default implementation of this logic.

   Unlike `enclosingMacros`, this is a def, which means that it gets recalculated on every invocation, so it might change depending on what is going on during macro expansion.

7. #### abstract def typecheck(tree: blackbox.Context.Tree, mode: blackbox.Context.TypecheckMode = TERMmode, pt: blackbox.Context.Type = universe.WildcardType, silent: Boolean = false, withImplicitViewsDisabled: Boolean = false, withMacrosDisabled: Boolean = false): blackbox.Context.Tree

   Typechecks the provided tree against the expected type `pt` in the macro callsite context under typechecking mode specified in `mode` with EXPRmode being default.

   Typechecks the provided tree against the expected type `pt` in the macro callsite context under typechecking mode specified in `mode` with EXPRmode being default. This populates symbols and types of the tree and possibly transforms it to reflect certain desugarings.

   If `silent` is false, `TypecheckException` will be thrown in case of a typecheck error. If `silent` is true, the typecheck is silent and will return `EmptyTree` if an error occurs. Such errors don't vanish and can be inspected by turning on -Ymacro-debug-verbose. Unlike in `inferImplicitValue` and `inferImplicitView`, `silent` is false by default.

   Typechecking can be steered with the following optional parameters: `withImplicitViewsDisabled` recursively prohibits implicit views (though, implicit vals will still be looked up and filled in), default value is false `withMacrosDisabled` recursively prohibits macro expansions and macro-based implicits, default value is false

   Exceptions thrown

     `scala.reflect.macros.TypecheckException`

8. #### abstract def untypecheck(tree: blackbox.Context.Tree): blackbox.Context.Tree

   In the current implementation of Scala's reflection API, untyped trees (also known as parser trees or unattributed trees) are observationally different from typed trees (also known as typer trees, typechecked trees or attributed trees),

   In the current implementation of Scala's reflection API, untyped trees (also known as parser trees or unattributed trees) are observationally different from typed trees (also known as typer trees, typechecked trees or attributed trees),

   Usually, if some compiler API takes a tree, then both untyped and typed trees will do. However in some cases, only untyped or only typed trees are appropriate. For example, eval only accepts untyped trees and one can only splice typed trees inside typed trees. Therefore in the current reflection API, there is a need in functions that go back and forth between untyped and typed trees. For this we have typecheck and `untypecheck`.

   Note that `untypecheck` is currently afflicted by https://issues.scala-lang.org/browse/SI-5464, which makes it sometimes corrupt trees so that they don't make sense anymore. Unfortunately, there's no workaround for that. We plan to fix this issue soon, but for now please keep it in mind.

   See also

     http://stackoverflow.com/questions/20936509/scala-macros-what-is-the-difference-between-typed-aka-typechecked-an-untyped

9. #### abstract def resetLocalAttrs(tree: blackbox.Context.Tree): blackbox.Context.Tree

   Recursively resets locally defined symbols and types in a given tree.

   Recursively resets locally defined symbols and types in a given tree. WARNING: Don't use this API, go for untypecheck instead.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use `c.untypecheck` instead

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Typers to any2stringadd[Typers] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Typers, B)

   Implicit information
     This member is added by an implicit conversion from Typers to ArrowAssoc[Typers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val TypecheckException: macros.TypecheckException.type

   See also

     `scala.reflect.macros.TypecheckException`

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### def ensuring(cond: (Typers) ⇒ Boolean, msg: ⇒ Any): Typers

   Implicit information
     This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (Typers) ⇒ Boolean): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): Typers

    Implicit information
      This member is added by an implicit conversion from Typers to Ensuring[Typers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Typers to StringFormat[Typers] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

18. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

20. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

24. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

25. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### def →[B](y: B): (Typers, B)

    Implicit information
      This member is added by an implicit conversion from Typers to ArrowAssoc[Typers] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def typeCheck(tree: blackbox.Context.Tree, pt: blackbox.Context.Type = universe.WildcardType, silent: Boolean = false, withImplicitViewsDisabled: Boolean = false, withMacrosDisabled: Boolean = false): blackbox.Context.Tree

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) Use `c.typecheck` instead

   See also

     `Typers.typecheck`

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Typers to any2stringadd[Typers]

### Inherited by implicit conversion StringFormat from Typers to StringFormat[Typers]

### Inherited by implicit conversion Ensuring from Typers to Ensuring[Typers]

### Inherited by implicit conversion ArrowAssoc from Typers to ArrowAssoc[Typers]

### Ungrouped